<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfResumoRetencaoERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfResumoRetencaoERP
 * @subpackage Arrays
 */
class ArrayOfResumoRetencaoERP extends AbstractStructArrayBase
{
    /**
     * The ResumoRetencaoERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ResumoRetencaoERP[]
     */
    public $ResumoRetencaoERP;
    /**
     * Constructor method for ArrayOfResumoRetencaoERP
     * @uses ArrayOfResumoRetencaoERP::setResumoRetencaoERP()
     * @param \StructType\ResumoRetencaoERP[] $resumoRetencaoERP
     */
    public function __construct(array $resumoRetencaoERP = array())
    {
        $this
            ->setResumoRetencaoERP($resumoRetencaoERP);
    }
    /**
     * Get ResumoRetencaoERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ResumoRetencaoERP[]|null
     */
    public function getResumoRetencaoERP()
    {
        return isset($this->ResumoRetencaoERP) ? $this->ResumoRetencaoERP : null;
    }
    /**
     * Set ResumoRetencaoERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ResumoRetencaoERP[] $resumoRetencaoERP
     * @return \ArrayType\ArrayOfResumoRetencaoERP
     */
    public function setResumoRetencaoERP(array $resumoRetencaoERP = array())
    {
        foreach ($resumoRetencaoERP as $arrayOfResumoRetencaoERPResumoRetencaoERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfResumoRetencaoERPResumoRetencaoERPItem instanceof \StructType\ResumoRetencaoERP) {
                throw new \InvalidArgumentException(sprintf('The ResumoRetencaoERP property can only contain items of \StructType\ResumoRetencaoERP, "%s" given', is_object($arrayOfResumoRetencaoERPResumoRetencaoERPItem) ? get_class($arrayOfResumoRetencaoERPResumoRetencaoERPItem) : gettype($arrayOfResumoRetencaoERPResumoRetencaoERPItem)), __LINE__);
            }
        }
        if (is_null($resumoRetencaoERP) || (is_array($resumoRetencaoERP) && empty($resumoRetencaoERP))) {
            unset($this->ResumoRetencaoERP);
        } else {
            $this->ResumoRetencaoERP = $resumoRetencaoERP;
        }
        return $this;
    }
    /**
     * Add item to ResumoRetencaoERP value
     * @throws \InvalidArgumentException
     * @param \StructType\ResumoRetencaoERP $item
     * @return \ArrayType\ArrayOfResumoRetencaoERP
     */
    public function addToResumoRetencaoERP(\StructType\ResumoRetencaoERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ResumoRetencaoERP) {
            throw new \InvalidArgumentException(sprintf('The ResumoRetencaoERP property can only contain items of \StructType\ResumoRetencaoERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ResumoRetencaoERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ResumoRetencaoERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ResumoRetencaoERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ResumoRetencaoERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ResumoRetencaoERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ResumoRetencaoERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ResumoRetencaoERP
     */
    public function getAttributeName()
    {
        return 'ResumoRetencaoERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfResumoRetencaoERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
